<?php
include_once 'conf.php';

$error_privilege = 'Low privilege!';

function safe($s)
{
	if(!get_magic_quotes_gpc())
	{
		if(is_array($s))
			foreach($s as $key=>$value)
				$s[$key] = addslashes($value);
		else
			$s=addslashes($s);
	}
	return $s;
}

function html_safe($s)
{
	return nl2br(htmlspecialchars(safe($s) )) ;
}

function is_admin()
{
	global $apps_pass;
	if( $_COOKIE['apps_verification'] == md5($apps_pass) )
		return true;
	return false;
}


/* Get Client IP */
function getip()  
{  
	if(!empty($_SERVER["HTTP_CLIENT_IP"]))  
		$cip = $_SERVER["HTTP_CLIENT_IP"];  
	else if(!empty($_SERVER["HTTP_X_FORWARDED_FOR"]))  
		$cip = $_SERVER["HTTP_X_FORWARDED_FOR"];  
	else if(!empty($_SERVER["REMOTE_ADDR"]))  
		$cip = $_SERVER["REMOTE_ADDR"];  
	else  
		$cip = "127.0.0.1";  
	return $cip;  
}

/* 截取文章前部分 2009-9-24 17:19:03 */
function make_preview( $str, $id ){
	$open=0;
	$closed=0;
	$s = $str;
	if( strlen($s)<=128 )
		return $s;
	$len = strlen($s);
	for( $i=0, $j=0; $i<$len; $i++, $j++ ){
		//utf8
		if( $str[$i] == '<' ){
			$open ++;
		}else if( $s[$i]=='>'){
			$closed ++;
		}else if( ord($s[$i])>=0xF0 ){
			$i+=3;
			$j+=2;
		}else if( ord($s[$i])>=224 ){
			$i+=2;
			$j+=1;
		}else if( ord($s[$i])>=0xC0 ){
			$i+=1;
		}
		if ( $open==$closed && $j > 128 ){
			$s = substr( $s, 0, $i+1 );
			$s .= " .... <span><a target=\"_blank\" href=\"" . $id .
				".html\"> continue </a></span>";
			return $s;
		}
	}
	return $s;
}


/*  page  navigation */
$nav = '';
$nav_offset = 0;
$nav_rows = 0;
$nav_rows_total = 0;
function make_nav($rowsPerPage, $table, $condition)
{
	global $nav, $nav_offset, $nav_rows, $nav_rows_total;
	//Default page num
	$pageNum = 1;
	if( isset( $_GET['page'] ) )
		$pageNum = (int)$_GET['page'];
	//开始读取的行
	$offset = ($pageNum - 1) * $rowsPerPage;
	// how many rows we have in database
	$query   = "SELECT COUNT(*) AS numRows FROM `$table` " . $condition;
	$result  = mysql_query($query) or die('Error, query failed');
	$row     = mysql_fetch_array($result, MYSQL_ASSOC);
	$numRows = $row['numRows'];
	$maxPage = ceil($numRows/$rowsPerPage);
	if ($numRows - $offset < $rowsPerPage )
		$rowsPerPage = $numRows - $offset;
	$nav  = "<tr class=\"tr_page_nav\"><td><b>page_nav: </b> ";
	//打印分页信息
	for($page = 1; $page <= $maxPage; $page++)
	{
		if ($page == $pageNum)
			$nav .= " [$page] "; // no need to create a link to current page
		else
			$nav .= ' <a href="javascript:void(0);" id="setpage-'.$page.'">['.$page.']</a>  ';
	}
	$nav .= "</td></tr>";
	$nav_offset = $offset;
	$nav_rows = $rowsPerPage;
	$nav_rows_total = $numRows;
	mysql_free_result($result);
	if( $maxPage>1 ) 
		return $nav;
	else
		return '';
}

switch( $_GET['item'] ){
	case 'login':
		if( isset($_POST['password']) ){
			$pass = $_POST['password'];
			setcookie( 'apps_verification', md5($pass) );
			echo '0';
		}else{
			echo '<h2>Simple Control Center</h2><table class="LoginTable" border="0">';
			if( is_logged() ){
				if( is_admin() ){
					echo '<tr width="100%"><td colspan="3"><div style="color:red">Administrator, welcome back!</div></td></tr>';
				}else{
					echo '<tr width="100%"><td colspan="3"><div style="color:red">I\'m sorry! Verification failed.</div></td></tr>';
				}
				echo '	<tr width="100%"><td><a id="logout" href="javascript:void(0);">Logout</a> &nbsp; &nbsp; &nbsp; &nbsp; </td>
					<td id="td_backup"><a id="backup" href="javascript:void(0);">Backup Database</a> &nbsp; &nbsp; &nbsp; &nbsp; </td> 
					<td><a id="newtopic" href="javascript:void(0);">New Topic</a></td></tr></table>';
				echo '<hr><h2>Menu</h2><table id="type_edit">
					<tr class="tr_title"><td>ID</td><td>类别名称</td><td>顺序</td><td>样式</td><td></td></tr>
					<tr><td><span id="m_id">0</span></td>
						<td><input type="text" id="m_typename" size="10"></td>
						<td><input type="text" id="m_typeorder" value="0" size="5"></td>
						<td><input type="text" id="m_typestyle" value="0" size="5"></td>
						<td> <a href="javascript:void(0);" class="button" onclick="doSaveType();">添加/修改</a>
						</td></tr></table><hr>';
				echo '<table id="type_list"><tr class="tr_title"><td>ID</td><td width="100px">类型名称</td><td width="32px">顺序</td><td>样式</td><td width="100px"></td></tr>';
				$query  = 'SELECT * FROM `type` ORDER BY `order`';
				$result = mysql_query($query) or die('sql query error.');
				while( $row = mysql_fetch_array($result, MYSQL_ASSOC) ){
					echo 	' <tr><td>'.$row['type_id'].
						'</td><td id="type_name_'.$row['type_id'].'">'.$row['name'].
						'</td><td id="type_order_'.$row['type_id'].'">'.$row['order'].
						'</td><td id="type_style_'.$row['type_id'].'">'.$row['style'].
						'</td><td><a href="javascript:void(0);" class="button" id="edittype-'.$row['type_id'].'">编辑</a> &nbsp;'.
							'<a href="javascript:void(0);" class="button" id="deltype-'.$row['type_id'].'">删除</a>'.
						'</td></tr>';
				}
				echo '</table><hr>';
				echo '	<h2>Upload</h2><form method="POST" enctype="multipart/form-data" name="f" action="apps.php?item=upload" target="_blank">
					_To_: <input type="text" name="dest" size="30"><br>
					From: <input type="file" name="source" size="60"> &nbsp; 覆盖<input type="checkbox" name="cover_old" value="cover"><input type="submit" value="上传">
					</form>';
			}else{
				echo '<tr width="100%"><td>Password</td><td> <input type="password" id="password"> </td><td> <a href="javascript:void(0);" id="login">Login</a></td></tr></table>';
			}
		}
		break;
	case 'backup':
		if( !is_admin() ) die($error_privilege);
		$to = $backup_dir . '/'. date("YmdHis") . '.sql';
		$cmd = "mysqldump -h$dbhost -u$dbuser -p$dbpass $dbname --default-character-set=\"utf8\"> $to";
		system($cmd);
		echo 'Backup Success';
		break;
	case 'upload':
		if( !is_admin() ) die($error_privilege);
		$file = $_FILES['source'];
		$to = $_POST['dest'];
		$file_name = $file['name'] ;
		$tmp_name = $file['tmp_name'];
		if( $file['error']!=0 || !file_exists ( $tmp_name ) )
			die('Failed while uploading.');
		if( file_exists ( $to ) &&  !(isset($_POST['cover_old']) && $_POST['cover_old']=='cover') )
			die('File already exists.');
		if(PATH_SEPARATOR==':'){ //Linux
			move_uploaded_file ( $tmp_name, $to );
			if ( !file_exists ( $to ) )
				die('Failed to move file.'.$to );
		}else{ //Windows
			$tmp = iconv('utf-8', 'gbk', $to ); //利用iconv函数对文件名进行重新编码
			move_uploaded_file ( $tmp_name, $tmp );
			if ( !file_exists ( $tmp ) )
				die('Failed to move file.'.$to );
		}
		echo '<p>'.$file_name.' => '.$to. '<p>Uploaded successfully!';
		break;
	case 'type_edit':
		if( !is_admin() ) die($error_privilege);
		$type_id = $_POST['type_id']*1;
		$type_name = safe($_POST['type_name']);
		$type_order = $_POST['type_order']*1;
		$type_style = $_POST['type_style']*1;
		if( $type_id == '0' ){
			$query = "INSERT INTO `type`(`name`, `order`, `style`) VALUES('$type_name', $type_order, $type_style ) ";
		}else{
			$query = "UPDATE `type` SET `name`='$type_name', `order`=$type_order, `style`=$type_style WHERE `type_id`=$type_id";
		}
		$result  = mysql_query($query) or die('Error, query failed' .$query);
		echo '0';
		break;
	case 'type_delete':
		if( !is_admin() ) die($error_privilege);
		$type_id = $_POST['type_id']*1;
		$query = "SELECT * FROM `topic` WHERE `type_id` = $type_id";
		$result  = mysql_query($query) or die('Error, query failed' .$query);
		if( mysql_num_rows($result) > 0 )
			die('Delete all documents on this type first please!');
		$query = "DELETE FROM `type` WHERE `type_id` = $type_id";
		$result  = mysql_query($query) or die('Error, query failed' .$query);

		echo '0';
		break;
	case 'logout':
		setcookie( 'apps_verification', '0' );
		echo '0';
		break;
	case 'comment_post':
		$ip = getip();
		$name = html_safe( $_POST['name'] );
		$mail = html_safe( $_POST['mail'] );
		$content = html_safe( $_POST['content'] );
		$ctime = date("Y-m-d H:i:s");
		if( $content > 10000 )
			die( 'overflow...' );
		$topic_id = $_POST['topic_id'] * 1;
		if( $topic_id!=0 ){
			$query = "UPDATE `topic` SET `comments`=`comments`+1 WHERE `topic_id`=$topic_id";
			$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		}
		$query = "INSERT INTO `comment`(`topic_id`, `name`, `content`, `mail`, `ip`, `ctime` ) VALUES($topic_id, '$name', '$content', '$mail', '$ip', '$ctime' ) ";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		// For quick posting 
		setcookie('m_name', $name, time()+60*60*24*365, '/' );
		setcookie('m_mail', $mail, time()+60*60*24*365, '/' );
		echo '0';
		break;
	case 'comment_list':
		$topic_id = $_GET['topic_id']*1;
		if( $topic_id==0 ){ //guestbook
			$rows = 10;
			$condition = " WHERE `topic_id`=$topic_id ORDER BY `ctime` DESC";
			$nav_str = make_nav( $rows, 'comment', $condition );
			$f = $nav_rows_total - $nav_offset +1;
		}else if( $topic_id==-1 ){ //recent
			$rows = 10;
			$condition = " ORDER BY `ctime` DESC";
		}else{ //topic comment
			$rows = 20;
			$condition = " WHERE `topic_id`=$topic_id ORDER BY `ctime`";
			$nav_str = make_nav( $rows, 'comment', $condition );
			$f = $nav_offset;
		}
		echo '<table width="100%" class="LeaveTable" border="0"><tr><td>';
		if( $topic_id==-1 )
			$query = "SELECT `comment`.*, `topic`.`name` AS `topic_name`, `topic`.`private` from `comment` 
				LEFT JOIN `topic` ON `topic`.`topic_id`=`comment`.`topic_id` WHERE `topic`.`private`=false
				$condition LIMIT 0,10";
		else
			$query = "SELECT * from `comment` $condition LIMIT $nav_offset, $rows";
		$result  = mysql_query($query) or die('Error, query failed!' .$query . '<p>'.mysql_error().'</p>');
		while( $row = mysql_fetch_array($result, MYSQL_ASSOC) )
		{
			echo '<table class="table_comment_item" onmouseover="this.oldClassName=this.className;this.className=\'table_comment_item_hover\';"
				onmouseout="this.className=this.oldClassName;this.oldClassName=null;"><tr width="100%"><td class="td_comment_item"><span class="TopicInfo">';
			if( $topic_id==-1 ){
				if( isset($row['topic_name'])  )
					echo '<a class="a_title" href="'.$row['topic_id'].'.html" target="_blank">'.$row['topic_name'].'</a><br>';
				else
					echo '<a class="a_title" href="javascript:void(0);">Contact</a><br>';
			}else{
				if( $topic_id==0 )
					-- $f;
				else
					++ $f;
				echo str_pad($f, 3, "0", STR_PAD_LEFT) . 'F:';
			}
			echo ' <b>' . $row['name'] .'</b>&nbsp;&nbsp;&nbsp;&nbsp;ctime: ' . $row['ctime'].'&nbsp;&nbsp;&nbsp;&nbsp; ';
			if($row['mail']!='' )
				echo ' contact: '. $row['mail'] . '&nbsp;&nbsp;&nbsp;&nbsp;';
			if( is_logged() ){
				echo 'ip: '.$row['ip'].' &nbsp;&nbsp;';
				if( $row['disabled'] )
					echo ' <a href="javascript:void(0);" id="lockcomment-'.$row['comment_id'].'">[enable]</a> ';
				else
					echo ' <a href="javascript:void(0);" id="lockcomment-'.$row['comment_id'].'">[disable]</a> ';
				echo '<a href="javascript:void(0);" id="delcomment-'.$row['comment_id'].'"> [delete] </a>';
			}
			echo '</span><br>';
			if( $row['disabled'] && !is_admin() ) 
				echo '(disabled)';
			else
				echo $row['content'];
			echo '</td></tr></table>';
		}
		echo '</td></tr></table>';
		if( $topic_id!=-1 ){
			echo '<table width="100%" class="PageTable" border="0">' . $nav_str . '</table>';
			echo '<table width="100%" class="WriteTable" border="0">
				<tr><td>nickname</td><td><input id="m_name" type="text" size="10" maxlength="30" value="'. (isset($_COOKIE['m_name'])?$_COOKIE['m_name']:''). '"></td></tr>
				<tr><td>Email(QQ)</td><td><input id="m_mail" type="text" size="30" maxlength="100" value="'. (isset($_COOKIE['m_mail'])?$_COOKIE['m_mail']:''). '"></td></tr>
				<tr><td>what to say</td><td><textarea id="m_content" cols="70" rows="5"></textarea></td></tr>
				<tr><td></td><td><a href="javascript:void(0);" id="submit_comment-'.$topic_id.'">post</a></td></tr>
				<tr><td></td><td><span id="m_error" style="color:red"> </span></td></tr></table>';
		}
		break;
	case 'topic_list':
		$rows = 10;
		$type_id = $_GET['type_id'] * 1;
		if( is_admin() )
			$condition = " WHERE `topic`.`type_id`=$type_id ORDER BY `ctime` DESC";
		else
			$condition = " WHERE `topic`.`private`=false AND `topic`.`type_id`=$type_id ORDER BY `ctime` DESC";
		$nav_str = make_nav( $rows, 'topic', $condition );
		echo '<table width="100%" class="TopicListTable" border="0">';
		$query = "SELECT `topic`.*, `type`.`style` from `topic` 
			LEFT JOIN `type` ON `type`.`type_id`=`topic`.`type_id`
			$condition LIMIT $nav_offset, $rows";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		while( $row = mysql_fetch_array($result, MYSQL_ASSOC) )
		{
			echo '<tr width="100%"><td>';
			echo '<table width="100%"><tr><td><span class="'. ($row['private']?'TopicTitle_Private':'TopicTitle').'"><a target="_blank" href="' . $row['topic_id'] . '.html">';
			if( $row['style'] ==0 ){
				echo $row['title'];
			}else{
				echo $row['name'];
			}
			echo	'</a></span></td></tr>
				<tr><td><span class="TopicInfo">ctime: ' . $row['ctime'] . ' &nbsp; ' .	'mtime: ' . $row['mtime'] . ' &nbsp; 
				<a href="'.$row['topic_id'].'.html" target="_blank">read('.$row['access'].')</a>' .' &nbsp; 
				<a href="'.$row['topic_id'].'.html?go=last" target="_blank">comments(' . $row['comments'] .')</a> &nbsp; </span>';
			if( is_logged() ){
				echo ' 	<a href="javascript:void(0);" id="edit-'.$row['topic_id'].'"> [edit] </a>
					<a href="javascript:void(0);" id="deltopic-'.$row['topic_id'].'"> [delete] </a> ';
			}
			echo '</td></tr><tr><td class="TDViewContent">';
			if( $row['style'] ==0 ){
				echo make_preview($row['content'], $row['topic_id'] );
			}else{
				echo $row['title'];
			}
			echo '</td></tr></table><br>';
		}
		echo '</table><table width="100%" class="PageTable" border="0">' . $nav_str . '</table>';
		break;
	case 'topic_delete':
		if( !is_admin() ) die($error_privilege);
		$topic_id= $_POST['topic_id'] * 1;
		$query = "DELETE FROM `comment` WHERE `topic_id`=$topic_id";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		$query = "DELETE FROM `topic` WHERE `topic_id`=$topic_id";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		echo '0';
		break;
	case 'comment_delete':
		if( !is_admin() ) die($error_privilege);
		$comment_id= $_POST['comment_id'] * 1;
		$query = "DELETE FROM `comment` WHERE `comment_id`=$comment_id";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		echo '0';
		break;
	case 'comment_enable':
		if( !is_admin() ) die($error_privilege);
		$comment_id= $_POST['comment_id'] * 1;
		$query = "UPDATE `comment` SET `disabled`=(`disabled`=false) WHERE `comment_id`=$comment_id";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		echo '0';
		break;
	case 'topic_post':
		if( !is_admin() ) die($error_privilege);
		$topic_id = $_POST['topic_id'] * 1;
		$type_id = $_POST['type_id'] * 1;
		$name = safe( $_POST['name'] );
		$title = safe( $_POST['title'] );
		$private = $_POST['private'];
		if( $private=='1' )
			$private = 1;
		else
			$private = 0;
		$access = $_POST['access'] * 1;
		$comments = $_POST['comments'] * 1;
		$ctime = $_POST['ctime'];
		$mtime = date("Y-m-d H:i:s");
		$content = safe( $_POST['content'] );
		if( $topic_id == 0 ){
			$query = "INSERT INTO `topic`(`type_id`, `name`, `title`, `access`, `comments`, `ctime`, `content`, `private`, `mtime`) VALUES($type_id, '$name', '$title', '$access', '$comments',
				'$ctime', '$content', $private, '$mtime' )";
		}else{
			$query = "UPDATE `topic` SET `type_id`=$type_id, `name`='$name', `title`='$title', `content`='$content', `access`='$access', `ctime`='$ctime', 
				`comments`='$comments', `private`=$private, `mtime`='$mtime' WHERE `topic_id`=$topic_id ";
		}
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		echo '0';
		break;
	case 'topic_edit':
		$topic_id = $_POST['topic_id'] * 1;
		if( $topic_id!=0 ){
			$query = "SELECT * FROM `topic` WHERE `topic_id`=$topic_id";
			$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
			$row = mysql_fetch_array($result, MYSQL_ASSOC);
			$type_id = $row['type_id'];
			$name = $row['name'];
			$title = $row['title'];
			$access = $row['access'];
			$private = $row['private'];
			$comments = $row['comments'];
			$ctime = $row['ctime'];
			$content = $row['content'];
		}else{
			$type_id = 0;
			$name = '';
			$title = '';
			$access = 0;
			$private = false;
			$comments = 0;
			$ctime = date("Y-m-d H:i:s");
			$content = '';
		}
		echo '<table width="100%" class="EditTable" border="0"><tr><td>id</td><td><input id="m_id" type="text" size="10" maxlength="5" value="' . $topic_id . '"></td></tr>
			<tr><td>type</td><td><select id="m_belong">';
		$query = "SELECT `type_id`,`name` FROM `type` ORDER BY `order`";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		while( $row = mysql_fetch_array($result, MYSQL_ASSOC) ){
			echo '<option value="' .$row['type_id'] . '" ';
			if( $row['type_id']==$type_id )
				echo 'selected';
			echo '>'.$row['name'].'</option>';
		}
		echo '</select></td></td>
			<tr><td>name</td><td><input id="m_name" type="text" size="30" maxlength="30" value="' .$name .'"></td></tr>
			<tr><td>title</td><td><textarea id="m_title" cols="60" rows="3">' . $title .'</textarea></td></tr>
			<tr><td>access_count</td><td><input id="m_clicks" type="text" size="10" maxlength="5" value="' .$access. '"></td></tr>
			<tr><td>comment_count</td><td><input id="m_comments" type="text" size="10" maxlength="5" value="' .$comments. '"></td></tr>
			<tr><td>ctime</td><td><input id="m_dateTime" type="text" size="30" maxlength="30" value="' .$ctime. '"></td></tr>
			<tr><td>option</td><td><input id="m_private" type="checkbox" onclick="javascript:$(\'m_private\').value=($(\'m_private\').value==1?0:1);" 
				value="'.$private.'" '. ($private?'checked':'') .'>Private</td></tr>
			<tr><td>option</td><td><a href="javascript:void(0);" id="advance_edit">Advanced Editor</td></tr>
			<tr><td>content</td><td><textarea id="m_content" cols="60" rows="10">' .$content . '</textarea></td></tr>
			<tr><td> </td><td><a href="javascript:void(0);" id="submit_edit">Edit</a></td></tr>
			</table>';
		break;
	case 'menu_list':
		$query = "SELECT * FROM `type` ORDER BY `order`";
		$result  = mysql_query($query) or die('Error, query failed' .$query . '<p>'.mysql_error().'</p>');
		echo '	<table id="SideMenu" class="SideMenu"><tr align="center">';
		while( $row = mysql_fetch_array($result, MYSQL_ASSOC) ){
			echo '<td align="center"><a id="menu-'.$row['type_id'].'" href="javascript:void(0);">'.$row['name'].'</a></td>';
		}
		echo '	<td align="center"><a id="menu-contact" href="javascript:void(0);">Contact</a></td>
			<td align="center"><a id="menu-recent" href="javascript:void(0);">Recent</a></td>
			<td align="center"><a id="menu-autobio" href="javascript:void(0);">Autobio</a></td>
			<td align="center"><a id="menu-admin" href="javascript:void(0);">Edit</a></td>
			</tr></table>';
		break;
	default:
		die('shit...');
}

?>
