/* Copyright by Huang Guan (2007-10-28) *
 * Email: gdxxhg AT gmail.com
 */

/* bindClick */
var clickEvents = new Array()

function bindClick( t, fn )
{
	var e = new Object()
	e.id = t
	e.func = fn
	clickEvents.push( e )
}

function getTarget( e ){
	if( !e ) e = window.event
	return ((typeof e.target != "undefined") ? e.target : e.srcElement)
}

function down(e){
	if (!e)
		e = window.event
	var temp = getTarget( e )
	if( temp == null ) 
		return false
	s = temp.id
	var k = s.split('-')
	for( var p in clickEvents ){
		if( k[0] == clickEvents[p].id ){
			if( k.length == 1 ){
				clickEvents[p].func()
			}else if( k.length == 2 ){
				clickEvents[p].func(k[1])
			}
		}
	}
}
document.onmousedown = down

/* addLoadListener */
function addLoadListener(fn){
	if(typeof window.addEventListener !='undefined')
		window.addEventListener('load',fn,false)
	else if(typeof document.addEventListener !='undefined')
		document.addEventListener('load',fn,false)
	//else if(typeof window.attachEvent !='undefined')
	//	window.attachEvent('onload',fn)
	else{
		var oldfn=window.onload
		if(typeof window.onload !='function')
			window.onload=fn
		else
			window.onload=function(){
				oldfn()
				fn()
			}
	}
}


/* Quick Way to Get Element. */
function $()
{
  var elements = new Array()
  for (var i = 0; i < arguments.length; i++)
  {
	var element = arguments[i]
	if (typeof element == 'string')
	  element = document.getElementById(element)
	if (arguments.length == 1)
	  return element
	elements.push(element)
  }
  return elements
}

var http_request = false;
var request_function = null;
function makeRequest(url,method,data,request_fun) {
	http_request = false;
	request_function = request_fun;
	if (window.XMLHttpRequest) { // Mozilla, Safari,...
   		http_request = new XMLHttpRequest();
    		if (http_request.overrideMimeType) {
        		http_request.overrideMimeType('text/xml');
   		}
	} else if (window.ActiveXObject) { // IE
    		try {
       		 	http_request = new ActiveXObject("Msxml2.XMLHTTP");
    		} catch (e) {
        		try {
           			http_request = new ActiveXObject("Microsoft.XMLHTTP");
        		} catch (e) {}
    		}
	}

	if (!http_request) {
    		alert('Giving up :( Cannot create an XMLHTTP instance');
		return false;
	}
	http_request.onreadystatechange = alertContents;
	http_request.open(method, url, true);
          //定义传输的文件HTTP头信息
	http_request.setRequestHeader("Content-Type","application/x-www-form-urlencoded")
	http_request.setRequestHeader("If-Modified-Since","0")

	http_request.send(data);
}

function alertContents() {

	if (http_request.readyState == 4) {
	    //if (http_request.status == 200) {
	        if( request_function ){  
	        	request_function(http_request);       
	        }else{
	        	alert('function not ready.');  
		}              
	    //}
	}

}

/* cookie operations */
function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return "";
}
